diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/arm32/autoconf.c sys/arch/arm32/arm32/autoconf.c
*** sys/arch/arm32.orig/arm32/autoconf.c	Wed Jun 12 20:37:59 1996
--- sys/arch/arm32/arm32/autoconf.c	Thu Jun 13 02:56:50 1996
***************
*** 59,64 ****
--- 59,65 ----
  #include "rd.h"
  #include "sd.h"
  #include "cd.h"
+ #include "acd.h"
  #include "podulebus.h"
  
  extern dev_t rootdev;
***************
*** 92,97 ****
--- 93,101 ----
  #endif
  #if NSD > 0
  	{ "sd", 0x18 },
+ #endif
+ #if NCD > 0
+ 	{ "acd", 0x14 },
  #endif
  #if NCD > 0
  	{ "cd", 0x1a },
diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/arm32/autoconf.c.orig sys/arch/arm32/arm32/autoconf.c.orig
*** sys/arch/arm32.orig/arm32/autoconf.c.orig	Thu Jan  1 01:00:00 1970
--- sys/arch/arm32/arm32/autoconf.c.orig	Wed Jun 12 20:37:59 1996
***************
*** 0 ****
--- 1,295 ----
+ /* $NetBSD: autoconf.c,v 1.7 1996/06/12 19:42:23 mark Exp $ */
+ 
+ /*
+  * Copyright (c) 1994,1995 Mark Brinicombe.
+  * Copyright (c) 1994 Brini.
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *	This product includes software developed by Mark Brinicombe for
+  *      the NetBSD project.
+  * 4. The name of the company nor the name of the author may be used to
+  *    endorse or promote products derived from this software without specific
+  *    prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+  * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+  * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
+  * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+  * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * RiscBSD kernel project
+  *
+  * autoconf.c
+  *
+  * Autoconfiguration functions
+  *
+  * Created      : 08/10/94
+  */
+ 
+ #include <sys/param.h>
+ #include <sys/systm.h>
+ #include <sys/reboot.h>
+ #include <sys/disklabel.h>
+ #include <sys/device.h>
+ #include <sys/conf.h>
+ #include <sys/kernel.h>
+ #include <sys/malloc.h>
+ 
+ #include <machine/irqhandler.h>
+ #include <machine/bootconfig.h>
+ 
+ #include "wdc.h"
+ #include "fdc.h"
+ #include "rd.h"
+ #include "sd.h"
+ #include "cd.h"
+ #include "podulebus.h"
+ 
+ extern dev_t rootdev;
+ extern dev_t swapdev;
+ extern dev_t dumpdev;
+ extern dev_t argdev;
+ 
+ extern struct swdevt swdevt[];
+ 
+ extern char *boot_args;
+ extern int pmap_debug_level;
+ 
+ char *	strstr	__P((char */*s1*/, char */*s2*/));
+ long	strtoul __P((const char *, char **, int));
+ void	dumpconf __P(());
+ 
+ /* Table major numbers for the device names, NULL terminated */
+ 
+ struct {
+     char *name;
+     dev_t dev;
+ } rootdevices[] = {
+ #if NWDC > 0
+ 	{ "wd", 0x10 },
+ #endif
+ #if NFDC > 0
+ 	{ "fd", 0x11 },
+ #endif
+ #if NRD > 0
+ 	{ "rd", 0x12 },
+ #endif
+ #if NSD > 0
+ 	{ "sd", 0x18 },
+ #endif
+ #if NCD > 0
+ 	{ "cd", 0x1a },
+ #endif
+ 	{ NULL, 0x00 },
+ };
+ 
+ /* Decode a device name to a major and minor number */
+ 
+ dev_t
+ get_device(name)
+ 	char *name;
+ {
+ 	int loop;
+ 	int unit;
+ 	int part;
+     
+ 	if (strncmp(name, "/dev/", 5) == 0)
+ 		name += 5;
+ 
+ 	for (loop = 0; rootdevices[loop].name; ++loop) {
+ 		if (strncmp(name, rootdevices[loop].name,
+ 		    strlen(rootdevices[loop].name)) == 0) {
+ 			name += strlen(rootdevices[loop].name);
+ 
+ 			if (name[0] >= '0' && name[0] <= '9')
+ 				unit = name[0] - '0';
+ 			else if (name[0] == 0 || name[0] == ' ')
+ 				unit = 0;
+ 			else
+ 				unit = -1;
+ 			if (name[1] >= 'a' && name[1] <= 'z')
+ 				part = name[1] - 'a';
+ 			else if (name[1] == 0 || name[1] == ' ')
+ 				part = 0;
+ 			else
+ 				part = -1;
+ 
+ 			if (unit < 0 || unit > 9)
+ 				return(NODEV);
+ 			if (part < 0 || part > MAXPARTITIONS)
+ 				return(NODEV);
+ 			return(makedev(rootdevices[loop].dev,
+ 			    unit * MAXPARTITIONS + part));
+ 		}
+ 	} 
+ 	return(NODEV);  
+ }
+ 
+ 
+ /* Set the rootdev variable from the root specifier in the boot args */
+ 
+ void
+ set_root_device()
+ {
+ 	char *ptr;
+             
+ 	if (boot_args) {
+ 		ptr = strstr(boot_args, "root=");
+ 		if (ptr) {
+ 			ptr += 5;
+ 			rootdev = get_device(ptr);
+ 
+ #ifdef DEBUG              
+ 			if (pmap_debug_level >= 0)
+ 				printf("rootdev = %08x\n", rootdev);
+ #endif
+ 		}
+ 	}
+ 
+ 	if (rootdev == NODEV)
+ 		panic("No root device specified in boot config\n");
+ }
+ 
+ 
+ /* Set the swap devices from the swap specifiers in the boot ars */
+ 
+ void
+ set_swap_device()
+ {
+ 	char *ptr;
+ 	int nswap = 0;
+             
+ 	if (boot_args) {
+ 		ptr = boot_args;
+ 		do {
+ 			ptr = strstr(ptr, "swap=");
+ 			if (ptr) {
+ 				ptr += 5;
+ 				swdevt[nswap].sw_dev = get_device(ptr);
+ 
+ 				/*
+ 				 * Remember the first swap device
+ 				 */
+ 
+ 				if (nswap == 0)
+ 					swapdev = get_device(ptr);
+ 				++nswap;
+ 			}
+ 		} while (ptr);
+ 	}
+ }
+ 
+ 
+ /*
+  * Configure swap space and related parameters.
+  */
+ 
+ void
+ swapconf()
+ {
+ 	register struct swdevt *swp;
+ 	register int nblks;
+ 	int swapsize = -1;
+ 	int maj;
+ 	int s;		/* The spl stuff was here for debugging reaons */
+ 
+ 	/*
+ 	 * Loop round all the defined swap device configuring them.
+ 	 */
+ 
+ 	for (swp = swdevt; swp->sw_dev != NODEV; swp++) {
+ 		maj = major(swp->sw_dev);
+ 		if (maj > nblkdev)
+ 			break;
+ 		if (bdevsw[maj].d_psize) {
+ 			s = spltty();
+ 			printf("swap dev %04x ", swp->sw_dev);
+ 			(void)splx(s);
+ 			if (swapsize == -1)
+ 				nblks = (*bdevsw[maj].d_psize)(swp->sw_dev);
+   		  	else
+ 				nblks = swapsize;
+ 			s = spltty();
+ 			if (nblks == -1)
+ 				printf("-> device not configured for swap\n");
+ 			else
+ 				printf("-> %d bytes\n", nblks*DEV_BSIZE);
+ 			(void)splx(s);
+ 			if (nblks != -1 &&
+ 			    (swp->sw_nblks == 0 || swp->sw_nblks > nblks))
+ 				swp->sw_nblks = nblks;
+ 			swp->sw_nblks = ctod(dtoc(swp->sw_nblks));
+ 		}
+ 	}
+ }
+ 
+ 
+ /* Set up the root and swap device numbers, configure the swap space and dump space */
+ 
+ void
+ set_boot_devs()
+ {
+ 	set_root_device();
+ 	set_swap_device();
+ 
+ 	if (swapdev == NODEV && minor(rootdev) < (MAXPARTITIONS - 2))
+ 		swapdev = makedev(major(rootdev), minor(rootdev) + 1);
+ 
+ 	dumpdev = swapdev;
+ 	argdev = swapdev;
+ 	swdevt[0].sw_dev = swapdev;
+ 
+ 	swapconf();
+ 	dumpconf();
+ }
+ 
+ 
+ /*
+  * void configure()
+  *
+  * Configure all the root devices
+  * The root devices are expected to configure their own children
+  */
+ 
+ void
+ configure()
+ {
+ 
+ /*
+  * Configure all the roots.
+  * We have to have a mainbus
+  */
+ 
+ 	config_rootfound("mainbus", NULL);
+ #if NPODULEBUS > 0
+ 	config_rootfound("podulebus", NULL);
+ #endif
+ 
+ /* Debugging information */
+ 
+ 	printf("ipl_bio=%08x ipl_net=%08x ipl_tty=%08x ipl_clock=%08x ipl_imp=%08x ipl_none=%08x\n",
+ 	    irqmasks[IPL_BIO], irqmasks[IPL_NET], irqmasks[IPL_TTY],
+ 	    irqmasks[IPL_CLOCK], irqmasks[IPL_IMP], irqmasks[IPL_NONE]);
+ 
+ /* Time to start taking interrupts so lets open the flood gates .... */
+          
+ 	(void)spl0();
+ }
+ 
+ /* End of autoconf.c */
diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/arm32/conf.c sys/arch/arm32/arm32/conf.c
*** sys/arch/arm32.orig/arm32/conf.c	Mon Jun  3 22:33:15 1996
--- sys/arch/arm32/arm32/conf.c	Thu Jun 13 02:56:51 1996
***************
*** 77,82 ****
--- 77,84 ----
  bdev_decl(vnd);
  #include "ccd.h"
  bdev_decl(ccd);
+ #include "acd.h"
+ bdev_decl(acd);
  
  /* Block devices */
  
***************
*** 101,107 ****
  	bdev_disk_init(NFDC, fd),	/* 17: floppy diskette */
  	bdev_disk_init(NRD, rd),	/* 18: ramdisk */
  	bdev_disk_init(NVND,vnd),	/* 19: vnode disk driver */
! 	bdev_lkm_dummy(),		/* 20: */
   	bdev_disk_init(NCCD,ccd),	/* 21: concatenated disk driver */
  	bdev_lkm_dummy(),		/* 22: */
  	bdev_lkm_dummy(),		/* 23: */
--- 103,109 ----
  	bdev_disk_init(NFDC, fd),	/* 17: floppy diskette */
  	bdev_disk_init(NRD, rd),	/* 18: ramdisk */
  	bdev_disk_init(NVND,vnd),	/* 19: vnode disk driver */
! 	bdev_disk_init(NACD,acd),	/* 20: ATAPI CD-ROM */
   	bdev_disk_init(NCCD,ccd),	/* 21: concatenated disk driver */
  	bdev_lkm_dummy(),		/* 22: */
  	bdev_lkm_dummy(),		/* 23: */
***************
*** 244,249 ****
--- 246,252 ----
  cdev_decl(tun);
  cdev_decl(vnd);
  cdev_decl(ccd);
+ cdev_decl(acd);
  #include "quadmouse.h"
  cdev_decl(quadmouse);
  #include "pms.h"
***************
*** 284,290 ****
  	cdev_disk_init(NFDC, fd),       /* 17: floppy diskette */
  	cdev_disk_init(NRD, rd),        /* 18: ram disk driver */
  	cdev_disk_init(NVND,vnd),       /* 19: vnode disk driver */
! 	cdev_lkm_dummy(),		/* 20: */
   	cdev_disk_init(NCCD,ccd),	/* 21: concatenated disk driver */
  	cdev_lkm_dummy(),		/* 22: */
  	cdev_lkm_dummy(),		/* 23: */
--- 287,293 ----
  	cdev_disk_init(NFDC, fd),       /* 17: floppy diskette */
  	cdev_disk_init(NRD, rd),        /* 18: ram disk driver */
  	cdev_disk_init(NVND,vnd),       /* 19: vnode disk driver */
! 	cdev_disk_init(NACD,acd),	/* 20: ATAPI CD-ROM */
   	cdev_disk_init(NCCD,ccd),	/* 21: concatenated disk driver */
  	cdev_lkm_dummy(),		/* 22: */
  	cdev_lkm_dummy(),		/* 23: */
***************
*** 359,365 ****
      /* 17 */        17,
      /* 18 */        18,
      /* 19 */        19,
!     /* 20 */        NODEV,
      /* 21 */        21,
      /* 22 */        NODEV,
      /* 23 */        NODEV,
--- 362,368 ----
      /* 17 */        17,
      /* 18 */        18,
      /* 19 */        19,
!     /* 20 */        20,
      /* 21 */        21,
      /* 22 */        NODEV,
      /* 23 */        NODEV,
diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/arm32/conf.c.orig sys/arch/arm32/arm32/conf.c.orig
*** sys/arch/arm32.orig/arm32/conf.c.orig	Thu Jan  1 01:00:00 1970
--- sys/arch/arm32/arm32/conf.c.orig	Mon Jun  3 22:33:15 1996
***************
*** 0 ****
--- 1,430 ----
+ /* $NetBSD: conf.c,v 1.8 1996/06/03 21:36:14 mark Exp $ */
+ 
+ /*
+  * Copyright (c) 1994 Mark Brinicombe.
+  * Copyright (c) 1994 Brini.
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *	This product includes software developed by Mark Brinicombe.
+  * 4. The name of the company nor the name of the author may be used to
+  *    endorse or promote products derived from this software without specific
+  *    prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+  * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+  * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
+  * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+  * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * RiscBSD kernel project
+  *
+  * conf.c
+  *
+  * Character and Block Device configuration
+  * Console configuration
+  *
+  * Defines the structures cdevsw and constab
+  *
+  * Created      : 17/09/94
+  */
+  
+ #include <sys/param.h>
+ #include <sys/systm.h>
+ #include <sys/buf.h>
+ #include <sys/ioctl.h>
+ #include <sys/tty.h>
+ #include <sys/conf.h>
+ #include <sys/vnode.h>
+ 
+ int     ttselect        __P((dev_t, int, struct proc *));
+ 
+ #ifndef LKM
+ #define lkmenodev       enodev
+ #else
+ int     lkmenodev();
+ #endif
+ 
+ #include "wdc.h"
+ bdev_decl(wd);
+ bdev_decl(sw);
+ #include "fdc.h"
+ bdev_decl(fd);
+ #include "rd.h"
+ bdev_decl(rd);
+ #include "sd.h"
+ bdev_decl(sd);
+ #include "st.h"
+ bdev_decl(st);
+ #include "cd.h"
+ bdev_decl(cd);
+ #include "vnd.h"
+ bdev_decl(vnd);
+ #include "ccd.h"
+ bdev_decl(ccd);
+ 
+ /* Block devices */
+ 
+ struct bdevsw bdevsw[] = {
+ 	bdev_lkm_dummy(),		/*  0: */
+ 	bdev_swap_init(1, sw),		/*  1: swap pseudo-device */
+ 	bdev_lkm_dummy(),		/*  2: */
+ 	bdev_lkm_dummy(),		/*  3: */
+ 	bdev_lkm_dummy(),		/*  4: */
+ 	bdev_lkm_dummy(),		/*  5: */
+ 	bdev_lkm_dummy(),		/*  6: */
+ 	bdev_lkm_dummy(),		/*  7: */
+ 	bdev_lkm_dummy(),		/*  8: */
+ 	bdev_lkm_dummy(),		/*  9: */
+ 	bdev_lkm_dummy(),		/* 10: */
+ 	bdev_lkm_dummy(),		/* 11: */
+ 	bdev_lkm_dummy(),		/* 12: */
+ 	bdev_lkm_dummy(),		/* 13: */
+ 	bdev_lkm_dummy(),		/* 14: */
+ 	bdev_lkm_dummy(),		/* 15: */
+ 	bdev_disk_init(NWDC, wd),	/* 16: Internal IDE disk */
+ 	bdev_disk_init(NFDC, fd),	/* 17: floppy diskette */
+ 	bdev_disk_init(NRD, rd),	/* 18: ramdisk */
+ 	bdev_disk_init(NVND,vnd),	/* 19: vnode disk driver */
+ 	bdev_lkm_dummy(),		/* 20: */
+  	bdev_disk_init(NCCD,ccd),	/* 21: concatenated disk driver */
+ 	bdev_lkm_dummy(),		/* 22: */
+ 	bdev_lkm_dummy(),		/* 23: */
+ 	bdev_disk_init(NSD,sd),		/* 24: SCSI disk */
+ 	bdev_tape_init(NST,st),		/* 25: SCSI tape */
+ 	bdev_disk_init(NCD,cd),		/* 26: SCSI cdrom */
+ 	bdev_lkm_dummy(),		/* 27: */
+ 	bdev_lkm_dummy(),		/* 28: */
+ 	bdev_lkm_dummy(),		/* 29: */
+ 	bdev_lkm_dummy(),		/* 30: */
+ 	bdev_lkm_dummy(),		/* 31: */
+ 	bdev_lkm_dummy(),		/* 32: */
+ 	bdev_lkm_dummy(),		/* 33: */
+ 	bdev_lkm_dummy(),		/* 34: */
+ 	bdev_lkm_dummy(),		/* 35: */
+ 	bdev_lkm_dummy(),		/* 36: */
+ 	bdev_lkm_dummy(),		/* 37: */
+ 	bdev_lkm_dummy(),		/* 38: */
+ 	bdev_lkm_dummy(),		/* 39: */
+ 	bdev_lkm_dummy(),		/* 40: */
+ 	bdev_lkm_dummy(),		/* 41: */
+ 	bdev_lkm_dummy(),		/* 42: */
+ 	bdev_lkm_dummy(),		/* 43: */
+   };
+ 
+ int nblkdev = sizeof(bdevsw) / sizeof(bdevsw[0]);
+ 
+ 
+ /* Character device declarations */
+ 
+ /* open, close, read, write, ioctl, tty, mmap */
+ #define cdev_physcon_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), dev_init(c,n,read), \
+ 	dev_init(c,n,write), dev_init(c,n,ioctl), dev_init(c,n,stop), \
+ 	dev_init(c,n,tty), ttselect, dev_init(c,n,mmap), 0 }
+ 
+ /* open, close, write, ioctl */
+ #define cdev_lpt_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), (dev_type_read((*))) enodev, \
+ 	dev_init(c,n,write), dev_init(c,n,ioctl), (dev_type_stop((*))) enodev, \
+ 	0, seltrue, (dev_type_mmap((*))) enodev, 0 }
+ 
+ /* open, close, write, ioctl */
+ #define cdev_beep_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), (dev_type_read((*))) enodev, \
+ 	(dev_type_write((*))) enodev, dev_init(c,n,ioctl), \
+ 	(dev_type_stop((*))) enodev, \
+ 	0, seltrue, (dev_type_mmap((*))) enodev, 0 }
+ 
+ /* open, close, write, ioctl */
+ #define cdev_kbd_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), dev_init(c,n,read), \
+ 	(dev_type_write((*))) enodev, dev_init(c,n,ioctl), \
+ 	(dev_type_stop((*))) enodev, \
+ 	0, dev_init(c,n,select), (dev_type_mmap((*))) enodev, 0 }
+ 
+ /* open, close, write, ioctl */
+ #define cdev_cpu_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), (dev_type_read((*))) enodev, \
+ 	(dev_type_write((*))) enodev, dev_init(c,n,ioctl), \
+ 	(dev_type_stop((*))) enodev, \
+ 	0, seltrue, (dev_type_mmap((*))) enodev, 0 }
+ 
+ /* open, close, write, ioctl */
+ #define cdev_vidcvid_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), (dev_type_read((*))) enodev, \
+ 	(dev_type_write((*))) enodev, dev_init(c,n,ioctl), \
+ 	(dev_type_stop((*))) enodev, \
+ 	0, seltrue, dev_init(c,n,mmap), 0 }
+ 
+ /* open, close, write, ioctl */
+ #define cdev_uk_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), dev_init(c,n,read), \
+ 	dev_init(c,n,write), dev_init(c,n,ioctl), \
+ 	(dev_type_stop((*))) enodev, \
+ 	0, seltrue, (dev_type_mmap((*))) enodev, 0 }
+ 
+ /* open, close, read, ioctl */
+ #define cdev_ss_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), dev_init(c,n,read), \
+ 	(dev_type_write((*))) enodev, dev_init(c,n,ioctl), \
+ 	(dev_type_stop((*))) enodev, 0, seltrue, \
+ 	(dev_type_mmap((*))) enodev }
+ 
+ /* open, close, write, ioctl */
+ #define cdev_iic_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), dev_init(c,n,read), \
+ 	dev_init(c,n,write), dev_init(c,n,ioctl), (dev_type_stop((*))) enodev, \
+ 	0, seltrue, (dev_type_mmap((*))) enodev, 0 }
+ 
+ /* open, close, write, ioctl */
+ #define cdev_rtc_init(c,n) { \
+ 	dev_init(c,n,open), dev_init(c,n,close), dev_init(c,n,read), \
+ 	dev_init(c,n,write), dev_init(c,n,ioctl), (dev_type_stop((*))) enodev, \
+ 	0, seltrue, (dev_type_mmap((*))) enodev, 0 }
+ 
+ cdev_decl(cn);
+ cdev_decl(ctty);
+ #include "vt.h"                                 
+ cdev_decl(physcon);
+ cdev_decl(vidcvideo);
+ #define mmread  mmrw
+ #define mmwrite mmrw
+ cdev_decl(mm);
+ cdev_decl(wd);
+ cdev_decl(sw);
+ #include "pty.h"
+ #define ptstty          ptytty
+ #define ptsioctl        ptyioctl
+ cdev_decl(pts);
+ #define ptctty          ptytty
+ #define ptcioctl        ptyioctl
+ cdev_decl(ptc);
+ cdev_decl(log);
+ #include "com.h"
+ cdev_decl(com);
+ #include "lpt.h"
+ cdev_decl(lpt);
+ cdev_decl(fd);
+ dev_decl(filedesc,open);
+ cdev_decl(rd);
+ #include "bpfilter.h"
+ cdev_decl(bpf);
+ cdev_decl(sd);
+ cdev_decl(st);
+ cdev_decl(cd);
+ #include "ch.h"
+ cdev_decl(ch);
+ #include "uk.h"
+ cdev_decl(uk);
+ #include "ss.h"
+ cdev_decl(ss);
+ #ifdef LKM
+ #define	NLKM	1
+ #else
+ #define	NLKM	0
+ #endif
+ cdev_decl(lkm);
+ #include "tun.h"
+ cdev_decl(tun);
+ cdev_decl(vnd);
+ cdev_decl(ccd);
+ #include "quadmouse.h"
+ cdev_decl(quadmouse);
+ #include "pms.h"
+ cdev_decl(pms);
+ #include "beep.h"
+ cdev_decl(beep);
+ #include "kbd.h"
+ cdev_decl(kbd);
+ #include "audio.h"
+ cdev_decl(audio);
+ #include "cpu.h"
+ cdev_decl(cpu);
+ #include "iic.h"
+ cdev_decl(iic);
+ #include "rtc.h"
+ cdev_decl(rtc);
+ 
+ /* Character devices */
+ 
+ struct cdevsw cdevsw[] = {
+ 	cdev_mm_init(1, mm),            /*  0: /dev/{null,mem,kmem,...} */
+ 	cdev_swap_init(1, sw),          /*  1: /dev/drum (swap pseudo-device) */
+ 	cdev_cn_init(1, cn),            /*  2: virtual console */
+ 	cdev_ctty_init(1,ctty),         /*  3: controlling terminal */
+ 	cdev_physcon_init(NVT, physcon),  /*  4: RPC console */
+         cdev_log_init(1,log),           /*  5: /dev/klog */
+ 	cdev_ptc_init(NPTY,ptc),        /*  6: pseudo-tty master */
+ 	cdev_tty_init(NPTY,pts),        /*  7: pseudo-tty slave */
+ 	cdev_lpt_init(NLPT,lpt),        /*  8: parallel printer */
+ 	cdev_mouse_init(NQUADMOUSE,quadmouse),       /* 9: quadmouse driver */
+ 	cdev_beep_init(NBEEP,beep),	/* 10: simple beep device */
+ 	cdev_kbd_init(NKBD,kbd),	/* 11: kbd device */
+ 	cdev_tty_init(NCOM,com),        /* 12: serial port */
+ 	cdev_lkm_dummy(),		/* 13: */
+ 	cdev_lkm_dummy(),		/* 14: */
+ 	cdev_lkm_dummy(),		/* 15: */
+ 	cdev_disk_init(NWDC, wd),       /* 16: ST506/ESDI/IDE disk */
+ 	cdev_disk_init(NFDC, fd),       /* 17: floppy diskette */
+ 	cdev_disk_init(NRD, rd),        /* 18: ram disk driver */
+ 	cdev_disk_init(NVND,vnd),       /* 19: vnode disk driver */
+ 	cdev_lkm_dummy(),		/* 20: */
+  	cdev_disk_init(NCCD,ccd),	/* 21: concatenated disk driver */
+ 	cdev_lkm_dummy(),		/* 22: */
+ 	cdev_lkm_dummy(),		/* 23: */
+ 	cdev_disk_init(NSD,sd),	    	/* 24: SCSI disk */
+ 	cdev_tape_init(NST,st),	   	/* 25: SCSI tape */
+ 	cdev_disk_init(NCD,cd),	    	/* 26: SCSI CD-ROM */
+ 	cdev_ch_init(NCH,ch),	 	/* 27: SCSI autochanger */
+ 	cdev_ch_init(NUK,uk),	 	/* 28: SCSI unknown */
+ 	cdev_ss_init(NSS,ss),	 	/* 29: SCSI scanner */
+ 	cdev_lkm_dummy(),		/* 30: */
+ 	cdev_lkm_dummy(),		/* 31: */
+ 	cdev_bpftun_init(NBPFILTER,bpf),/* 32: Berkeley packet filter */
+         cdev_bpftun_init(NTUN,tun),     /* 33: network tunnel */
+         cdev_fd_init(1,filedesc),       /* 34: file descriptor pseudo-device */
+ 	cdev_lkm_init(NLKM,lkm),        /* 35: loadable module driver */
+ 	cdev_audio_init(NAUDIO,audio),	/* 36: generic audio I/O */
+ 	cdev_vidcvid_init(1,vidcvideo),	/* 37: vidcvideo device */
+ 	cdev_cpu_init(NCPU,cpu),	/* 38: cpu device */
+ 	cdev_lkm_dummy(),		/* 39: */
+ 	cdev_mouse_init(NPMS,pms),      /* 40: PS2 mouse driver */
+ 	cdev_lkm_dummy(),		/* 41: */
+ 	cdev_iic_init(NIIC, iic),	/* 42: IIC bus driver */
+ 	cdev_rtc_init(NRTC, rtc),	/* 43: RTC driver */
+ };
+ 
+ int nchrdev = sizeof(cdevsw) / sizeof(cdevsw[0]);
+ 
+ int mem_no = 0; 	/* major device number of memory special file */
+ 
+ 
+ /*
+  * Returns true if dev is /dev/mem or /dev/kmem.
+  */
+ int
+ iskmemdev(dev)
+ 	dev_t dev;
+ {
+ 	return (major(dev) == mem_no && minor(dev) < 2);
+ }
+ 
+ /*
+  * Returns true if dev is /dev/zero.
+  */
+ int
+ iszerodev(dev)
+ 	dev_t dev;
+ {
+ 	return (major(dev) == mem_no && minor(dev) == 3);
+ }
+ 
+ 
+ static int chrtoblktbl[] = {
+ /* XXXX This needs to be dynamic for LKMs. */
+     /*VCHR*/        /*VBLK*/
+     /*  0 */        NODEV,
+     /*  1 */        1,
+     /*  2 */        NODEV,
+     /*  3 */        NODEV,
+     /*  4 */        NODEV,
+     /*  5 */        NODEV,
+     /*  6 */        NODEV,
+     /*  7 */        NODEV,
+     /*  8 */        NODEV,
+     /*  9 */        NODEV,
+     /* 10 */        NODEV,
+     /* 11 */        NODEV,
+     /* 12 */        NODEV,
+     /* 13 */        NODEV,
+     /* 14 */        NODEV,
+     /* 15 */        NODEV,
+     /* 16 */        16,
+     /* 17 */        17,
+     /* 18 */        18,
+     /* 19 */        19,
+     /* 20 */        NODEV,
+     /* 21 */        21,
+     /* 22 */        NODEV,
+     /* 23 */        NODEV,
+     /* 24 */        24,
+     /* 25 */        25,
+     /* 26 */        26,
+     /* 27 */        NODEV,
+     /* 28 */        NODEV,
+     /* 29 */        NODEV,
+     /* 30 */        NODEV,
+     /* 31 */        NODEV,
+     /* 32 */        NODEV,
+     /* 33 */        NODEV,
+     /* 34 */        NODEV,
+     /* 35 */        NODEV,
+     /* 36 */        NODEV,
+     /* 37 */        NODEV,
+     /* 38 */        NODEV,
+     /* 39 */        NODEV,
+     /* 40 */        NODEV,
+     /* 41 */        NODEV,
+     /* 42 */        NODEV,
+     /* 43 */        NODEV,
+ };
+ 
+ /*
+  * Convert a character device number to a block device number.
+  */
+  
+ dev_t
+ chrtoblk(dev)
+ 	dev_t dev;
+ {
+ 	int blkmaj;
+                   
+ 	if (major(dev) >= nchrdev)
+ 		return (NODEV);
+ 
+ 	blkmaj = chrtoblktbl[major(dev)];
+ 	if (blkmaj == NODEV)
+ 		return (NODEV);
+ 	return (makedev(blkmaj, minor(dev)));
+ }
+                                                                                    
+ /*
+  * This entire table could be autoconfig()ed but that would mean that
+  * the kernel's idea of the console would be out of sync with that of
+  * the standalone boot.  I think it best that they both use the same
+  * known algorithm unless we see a pressing need otherwise.
+  */
+ 
+ #include <dev/cons.h>
+ 
+ cons_decl(rpcconsole);
+ cons_decl(com);   
+        
+ struct consdev constab[] = {
+ #if (NVT + NRPC > 0)
+ 	cons_init(rpcconsole),
+ #endif
+ 
+ /*#if (NCOM > 0)
+ 	cons_init(com),
+ #endif*/
+ 	{ 0 },
+ };
+                            
+ /* End of conf.c */
diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/conf/VOYAGER sys/arch/arm32/conf/VOYAGER
*** sys/arch/arm32.orig/conf/VOYAGER	Thu Jun 13 02:08:19 1996
--- sys/arch/arm32/conf/VOYAGER	Thu Jun 13 02:56:51 1996
***************
*** 124,129 ****
--- 124,132 ----
  wdc0    at mainbus? base 0x002107c0 irq 9
  wd*     at wdc? drive ?
  
+ atapibus* at wdc?
+ acd* at atapibus? drive?
+ 
  # Floppy disk controller
  fdc0    at mainbus? base 0x00210fc0 irq 12 dack 0x00002000
  fd0     at fdc? drive ?
diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/conf/VOYAGER.orig sys/arch/arm32/conf/VOYAGER.orig
*** sys/arch/arm32.orig/conf/VOYAGER.orig	Thu Jan  1 01:00:00 1970
--- sys/arch/arm32/conf/VOYAGER.orig	Thu Jun 13 02:08:19 1996
***************
*** 0 ****
--- 1,201 ----
+ #
+ #	VOYAGER -- Mark's master development machine
+ #
+ 
+ include	"std.arm32"
+ 
+ # estimated number of users
+ 
+ maxusers	32
+ 
+ # Standard system options
+ 
+ options		TIMEZONE=0	# time zone to adjust RTC time by
+ options		DST=0		# daylight savings time used by RTC
+ options		SWAPPAGER	# paging; REQUIRED
+ options		VNODEPAGER	# mmap() of files
+ options		DEVPAGER	# mmap() of devices
+ 
+ # CPU options
+ 
+ options		CPU_ARM6
+ options		CPU_LATE_ABORT	# ARM7XX compatibility
+ 
+ # FPA options
+ 
+ #options		FPE		# Single precision FPE
+ options		ARMFPE		# ARM Ltd FPE
+ 
+ # File system options
+ 
+ options		FFS		# UFS
+ #options	QUOTA		# UFS quotas
+ #options	LFS		# log-structured file system
+ options		MFS		# memory file system
+ 
+ options		CD9660		# ISO 9660 + Rock Ridge file system
+ options		MSDOSFS		# MS-DOS file system
+ options		FDESC		# /dev/fd
+ options		FIFO		# FIFOs; RECOMMENDED
+ options		KERNFS		# /kern
+ options		NULLFS		# loopback file system
+ #options	PORTAL		# portal filesystem (still experimental)
+ options		PROCFS		# /proc
+ options		UMAPFS		# NULLFS + uid and gid remapping
+ options		UNION		# union file system
+ 
+ # Networking options
+ 
+ options		NFSCLIENT
+ options		NFSSERVER
+ options		GATEWAY		# packet forwarding
+ options		INET		# IP + ICMP + TCP + UDP
+ #options	NS		# XNS
+ #options	ISO,TPIP	# OSI
+ #options	EON		# OSI tunneling over IP
+ #options	CCITT,LLC,HDLC	# X.25
+ 
+ # Compatibility options
+ 
+ options		COMPAT_43
+ options		COMPAT_10
+ options		COMPAT_09
+ options         TCP_COMPAT_42   # TCP bug compatibility with 4.2BSD
+ 
+ # Shared memory options
+ 
+ options		SYSVMSG		# System V-like message queues
+ options		SYSVSEM		# System V-like semaphores
+ options		SYSVSHM		# System V-like memory sharing
+ options		SHMMAXPGS=1024	# 1024 pages is the default
+ 
+ # Device options
+ 
+ options		RAMDISK_HOOKS	# boottime setup of ramdisk
+ options		RAMDISK_SIZE=0	# Size in KBytes
+ options		PLIP		# Build plip device into lpt driver
+ 
+ # Development options
+ 
+ #options	ARM700BUGTRACK	# track the ARM700 swi bug
+ options		HYDRA		# Experimental hydra support
+ options		MPSUPPORT	# Experimental MP support
+ options		DIAGNOSTIC	# internally consistency checks
+ options		KTRACE		# system call tracing, a la ktrace(1)
+ options		IRQSTATS	# IRQ statistics
+ options		POSTMORTEM	# perform postmortem on panic
+ #options	ROTTEN_INNARDS	# show the gory bit of the postmortem
+ options		KSHELL		# kernel developemnt shell (debug)
+ options		LKM		# loadable kernel modules
+ #options	DEBUGTERM	# create a debug console
+ #options	KGDB		# remote kernel debugging
+ options		DDB		# in-kernel debugger
+ #makeoptions	DEBUG="-g"	# compile full symbol table
+ 
+ config		netbsd	swap generic
+ options		GENERIC
+ 
+ # The main bus device
+ mainbus0 at root
+ 
+ # The boot cpu
+ cpu0 at mainbus?
+ 
+ # The hydra multiprocessor device
+ hydrabus0 at mainbus?
+ 
+ #hcpu0 at hydrabus?
+ #hcpu1 at hydrabus? slot 0
+ #hcpu2 at hydrabus?
+ #hcpu3 at hydrabus?
+ 
+ # The vidc
+ vidcvideo0	at mainbus?
+ 
+ # generic VT console device
+ vt0     at mainbus?
+ vt1     at mainbus?
+ vt2     at mainbus?
+ vt3     at mainbus?
+ vt4     at mainbus?
+ vt5     at mainbus?
+ 
+ # IDE disk controller
+ wdc0    at mainbus? base 0x002107c0 irq 9
+ wd*     at wdc? drive ?
+ 
+ # Floppy disk controller
+ fdc0    at mainbus? base 0x00210fc0 irq 12 dack 0x00002000
+ fd0     at fdc? drive ?
+ 
+ # kbd via IOMD
+ kbd0	at mainbus? base 0x00000000
+ 
+ # quadrature mouse
+ quadmouse0	at mainbus? base 0x00000000 irq 6	# TMR1
+ #quadmouse0	at mainbus? base 0x00000000 irq 3	# VSYNC
+ 
+ # PS2 mouse
+ pms0	at mainbus? base 0x00000000
+ 
+ # Serial ports
+ com0    at mainbus? base 0x00210fe0 irq 10
+ #com1    at mainbus? base 0x00210be0
+ 
+ # Parallel ports
+ lpt0    at mainbus? base 0x002109e0 irq 0
+ 
+ # Crude sound device
+ beep0	at mainbus? base 0x00000000
+ 
+ # IIC bus device
+ iic0	at mainbus?
+ 
+ # RTC device
+ rtc0	at iic? addr 0xa0
+ 
+ # Podule bus device
+ podulebus0	at root
+ 
+ asc0	at podulebus?			# Acorn SCSI card
+ scsibus* at asc?
+ 
+ csc0	at podulebus?			# Cumana SCSI II card
+ scsibus* at csc?
+ 
+ ptsc0	at podulebus?			# Power-Tec SCSI II card
+ scsibus* at ptsc?
+ 
+ oak0	at podulebus?			# Oak SCSI I card
+ scsibus* at oak?
+ 
+ sd*	at scsibus? target ? lun ?	# SCSI disk drives
+ st*	at scsibus? target ? lun ?	# SCSI tape drives
+ cd*	at scsibus? target ? lun ?	# SCSI CD-ROM drives
+ ch*	at scsibus? target ? lun ?	# SCSI auto-changers
+ uk*	at scsibus? target ? lun ?	# SCSI unknown device
+ ss*	at scsibus? target ? lun ?	# SCSI scanner
+ 
+ #kie*	at podulebus? slot ? offset ?
+ 
+ ea0	at podulebus?			# Ether3 podules
+ eb0	at podulebus?			# EtherB network slot cards
+ eh0	at podulebus?			# EtherH network slot cards
+ ie0	at podulebus?			# Ether1 podules
+ 
+ pseudo-device	loop	1               # network loopback
+ pseudo-device   bpfilter 8              # packet filter
+ pseudo-device	sl	2               # CSLIP
+ pseudo-device	ppp	2		# PPP
+ pseudo-device	tun	2		# network tunneling over tty
+ 
+ pseudo-device   pty     32              # pseudo-terminals
+ pseudo-device	tb	1		# tablet line discipline
+ pseudo-device   vnd     4               # paging to files
+ pseudo-device	ccd	2		# concatenated disk devices
+ 
+ pseudo-device	rd	1		# Ramdisk device
+ 
+ makeoptions MONITOR="Taxan875+LR"
+ #makeoptions MONITOR="AKF60"
+ makeoptions MODES="1024,768,60 1024,768,70 800,600,60 640,480,60 1280,1024 1152,900"
